"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EnhanceStore = void 0;
const vuex_1 = require("vuex");
/**
 * methods override ordering must be
 * mapper > keys
 * root > namespaces
 */
class EnhanceStore {
    constructor(s) {
        this.store = new vuex_1.Store(s);
        this.dispatch = this.dispatch.bind(this);
    }
    dispatch(arg1, arg2) {
        return (...payload) => {
            const { dispatch } = this.store;
            if (arg2) {
                return dispatch(`${arg1}/${arg2}`, ...payload);
            }
            return dispatch(arg1, ...payload);
        };
    }
    mapGetters(k, u) {
        return (0, vuex_1.mapGetters)(k, u);
    }
    mapActions(k, u) {
        return (0, vuex_1.mapActions)(k, u);
    }
    mapMutations(k, u) {
        return (0, vuex_1.mapMutations)(k, u);
    }
    mapState(k, u) {
        return (0, vuex_1.mapState)(k, u);
    }
}
exports.EnhanceStore = EnhanceStore;
